<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::sdkInterfaces::DCFObserverInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.7.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html">sdkInterfaces</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html">DCFObserverInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::sdkInterfaces::DCFObserverInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_d_c_f_observer_interface_8h_source.html">DCFObserverInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::sdkInterfaces::DCFObserverInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1default_client_1_1_default_client.html" title="alexaClientSDK::defaultClient\l::DefaultClient" alt="" coords="5,95,201,136"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1sample_app_1_1_u_i_manager.html" title="alexaClientSDK::sampleApp\l::UIManager" alt="" coords="225,95,413,136"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a331005311f5460b056c37fff832da30e"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#a331005311f5460b056c37fff832da30e">State</a> { <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#a331005311f5460b056c37fff832da30eadd652546039b18970b8dcf2cff824268">State::UNINITIALIZED</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#a331005311f5460b056c37fff832da30ead0749aaba8b833466dfcbb0428e4f89c">State::SUCCESS</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#a331005311f5460b056c37fff832da30eac6179cb17067a08588ff65efb6d02cdd">State::FATAL_ERROR</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#a331005311f5460b056c37fff832da30ea338d7999ce17b46e8aff3f23d0436b06">State::RETRIABLE_ERROR</a>
 }</td></tr>
<tr class="memdesc:a331005311f5460b056c37fff832da30e"><td class="mdescLeft">&#160;</td><td class="mdescRight">The enum State describes the state of the DCF delegate.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#a331005311f5460b056c37fff832da30e">More...</a><br /></td></tr>
<tr class="separator:a331005311f5460b056c37fff832da30e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adb141ed1a4de98a9837ce3c35726f301"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301">Error</a> { <br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301add652546039b18970b8dcf2cff824268">Error::UNINITIALIZED</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301ad0749aaba8b833466dfcbb0428e4f89c">Error::SUCCESS</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301a9a10f345b0f755d461a8673a5e9ef6b4">Error::UNKNOWN_ERROR</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301a4a76a6ecac6e4077588fd966db329fa3">Error::FORBIDDEN</a>, 
<br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301a6a701b3f16c45b9d96fec4ac97805d9c">Error::SERVER_INTERNAL_ERROR</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301a0bbffe9eb8bbfc49246e867fccaefb73">Error::BAD_REQUEST</a>
<br />
 }</td></tr>
<tr class="memdesc:adb141ed1a4de98a9837ce3c35726f301"><td class="mdescLeft">&#160;</td><td class="mdescRight">The enum Error encodes possible errors which may occur when changing state.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301">More...</a><br /></td></tr>
<tr class="separator:adb141ed1a4de98a9837ce3c35726f301"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:afee75ccf1a822aa19c61e53d3fa676cb"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#afee75ccf1a822aa19c61e53d3fa676cb">~DCFObserverInterface</a> ()=default</td></tr>
<tr class="separator:afee75ccf1a822aa19c61e53d3fa676cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a39421094ce6a5482bbadbbfe585fa6bb"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#a39421094ce6a5482bbadbbfe585fa6bb">onDCFStateChange</a> (<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#a331005311f5460b056c37fff832da30e">State</a> newState, <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301">Error</a> error)=0</td></tr>
<tr class="separator:a39421094ce6a5482bbadbbfe585fa6bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">This interface is used to observe changes to the state of the DCF delegate. </p>
</div><h2 class="groupheader">Member Enumeration Documentation</h2>
<a id="adb141ed1a4de98a9837ce3c35726f301"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adb141ed1a4de98a9837ce3c35726f301">&#9670;&nbsp;</a></span>Error</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301">alexaClientSDK::avsCommon::sdkInterfaces::DCFObserverInterface::Error</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The enum Error encodes possible errors which may occur when changing state. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="adb141ed1a4de98a9837ce3c35726f301add652546039b18970b8dcf2cff824268"></a>UNINITIALIZED&#160;</td><td class="fielddoc"><p class="">The state (and hence the error) has not been initialized. </p>
</td></tr>
<tr><td class="fieldname"><a id="adb141ed1a4de98a9837ce3c35726f301ad0749aaba8b833466dfcbb0428e4f89c"></a>SUCCESS&#160;</td><td class="fielddoc"><p class="">Success. </p>
</td></tr>
<tr><td class="fieldname"><a id="adb141ed1a4de98a9837ce3c35726f301a9a10f345b0f755d461a8673a5e9ef6b4"></a>UNKNOWN_ERROR&#160;</td><td class="fielddoc"><p class="">An unknown error occurred. </p>
</td></tr>
<tr><td class="fieldname"><a id="adb141ed1a4de98a9837ce3c35726f301a4a76a6ecac6e4077588fd966db329fa3"></a>FORBIDDEN&#160;</td><td class="fielddoc"><p class="">The authorization failed. </p>
</td></tr>
<tr><td class="fieldname"><a id="adb141ed1a4de98a9837ce3c35726f301a6a701b3f16c45b9d96fec4ac97805d9c"></a>SERVER_INTERNAL_ERROR&#160;</td><td class="fielddoc"><p class="">The server encountered a runtime error. </p>
</td></tr>
<tr><td class="fieldname"><a id="adb141ed1a4de98a9837ce3c35726f301a0bbffe9eb8bbfc49246e867fccaefb73"></a>BAD_REQUEST&#160;</td><td class="fielddoc"><p class="">The request is missing a required parameter, has an invalid value, or is otherwise improperly formed. </p>
</td></tr>
</table>

</div>
</div>
<a id="a331005311f5460b056c37fff832da30e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a331005311f5460b056c37fff832da30e">&#9670;&nbsp;</a></span>State</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#a331005311f5460b056c37fff832da30e">alexaClientSDK::avsCommon::sdkInterfaces::DCFObserverInterface::State</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The enum State describes the state of the DCF delegate. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a331005311f5460b056c37fff832da30eadd652546039b18970b8dcf2cff824268"></a>UNINITIALIZED&#160;</td><td class="fielddoc"><p class="">DCF delegate not yet published. </p>
</td></tr>
<tr><td class="fieldname"><a id="a331005311f5460b056c37fff832da30ead0749aaba8b833466dfcbb0428e4f89c"></a>SUCCESS&#160;</td><td class="fielddoc"><p class="">The DCF publish message went through without issues. </p>
</td></tr>
<tr><td class="fieldname"><a id="a331005311f5460b056c37fff832da30eac6179cb17067a08588ff65efb6d02cdd"></a>FATAL_ERROR&#160;</td><td class="fielddoc"><p class="">The message did not go through because of issues that need fixing. </p>
</td></tr>
<tr><td class="fieldname"><a id="a331005311f5460b056c37fff832da30ea338d7999ce17b46e8aff3f23d0436b06"></a>RETRIABLE_ERROR&#160;</td><td class="fielddoc"><p class="">The message did not go through, but you can retry to see if you succeed. </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="afee75ccf1a822aa19c61e53d3fa676cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afee75ccf1a822aa19c61e53d3fa676cb">&#9670;&nbsp;</a></span>~DCFObserverInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::avsCommon::sdkInterfaces::DCFObserverInterface::~DCFObserverInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Virtual destructor to assure proper cleanup of derived types. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a39421094ce6a5482bbadbbfe585fa6bb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a39421094ce6a5482bbadbbfe585fa6bb">&#9670;&nbsp;</a></span>onDCFStateChange()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::DCFObserverInterface::onDCFStateChange </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#a331005311f5460b056c37fff832da30e">State</a>&#160;</td>
          <td class="paramname"><em>newState</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_d_c_f_observer_interface.html#adb141ed1a4de98a9837ce3c35726f301">Error</a>&#160;</td>
          <td class="paramname"><em>error</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Notification that an DCF delegate state has changed.</p>
<dl class="section note"><dt>Note</dt><dd>Implementations of this method must not call DCFDelegate methods because the DCFDelegate may be in a 'locked' state at the time this call is made. If you do, then you may end up with a deadlock.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newState</td><td>The new state of the DCF delegate. </td></tr>
    <tr><td class="paramname">error</td><td>The error associated to the state change. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1default_client_1_1_default_client.html#afe7dfc97c91f494971dbfec743cc00df">alexaClientSDK::defaultClient::DefaultClient</a>, and <a class="el" href="classalexa_client_s_d_k_1_1sample_app_1_1_u_i_manager.html#a7d58e356f131a735ee9db5309c97d5df">alexaClientSDK::sampleApp::UIManager</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/release/tools/avs-cpp-sdk-tools/cm/output2/autoCM_publicRepo/avs-device-sdk/AVSCommon/SDKInterfaces/include/AVSCommon/SDKInterfaces/<a class="el" href="_d_c_f_observer_interface_8h_source.html">DCFObserverInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.7.0 - Copyright 2016-2018 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
